
# Wrap-up

* Git makes things separated but interlinked!
    * separation of changes into commits - compare with standard "versioning" of dropbox/onedrive/owncloud or labeling v1.2 manually
    * separation of work into branches - compare with standard work in parallel - making copy of file and renaming, then "putting it together"
    * separation of work into forks - compare with "I will make my own copy of the whole folder"


<div class="fragment">

* GitLab creates a convenient working environment
  * merge requests
  * issues
  * assignements
  * and much much more...


   <div style="position:absolute;left:55%;top:55%">
   <img src="slides/img/fox.png">
   https://pixabay.com/images/id-5236832/
   </div>
</div>




# Wrap-up
## Glossary
* git
* repository
* fork
* commit
* branch
* merge
* merge/pull request

## Best practices

* Work on your <font color="red">own</font> branch (in your own fork), and **not** on `master` and **not** on `develop`
* Do **not commit** to `master`/`develop`, but **submit a merge request (MR)**
* Get your code **reviewed** by your peers (submit a merge request!)
* Submit a merge request **often**! (as soon as the feature is ready)
* Make commits often (keeps increments small)


